import javafx.scene.Group;

/**
 * スプライト
 */
public abstract class PRSprite extends Group {

	/** アプリケーション */
	public		PRApplication		application			= null;

	/** 速度 */
	public		double				mx					= 0.0;
	public		double				my					= 0.0;
	public		double				mz					= 0.0;

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 */
	public PRSprite(PRApplication application) {

		super();

		// アプリケーションを保持
		this.application = application;

	}

	/**
	 * 実行
	 */
	abstract public void run();

	/**
	 * 削除
	 */
	public void remove(){

		// 削除メソッド呼び出し
		application.removeNode(this);

	}

}
