import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;

/**
 * 地面
 */
public class PRSpriteGround extends PRSprite {

	private static float[]		POINTS		= {
		-100.0f, 0,  200.0f,
		-100.0f, 0, -200.0f,
		 100.0f, 0, -200.0f,
		 100.0f, 0,  200.0f
	};

	private static float[]		TEXCOORDS   = {
		0, 0,
		0, 1,
		1, 1,
		1, 0
	};

	private static int[]		FACES		= {
		0, 0, 1, 0, 2, 0,
		2, 0, 3, 0, 0, 0
	};

	/** マテリアル */
	private		PhongMaterial	material	= null;

	/**
	 * 初期化
	 */
	public static void init() {

		try{
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 */
	public PRSpriteGround(PRApplication application){

		// スーパークラスを呼び出す
		super(application);

		try{

			// メッシュビューを生成
			MeshView meshView = new MeshView();

			// メッシュを生成
			TriangleMesh mesh = new TriangleMesh();

			mesh.getPoints().addAll(POINTS);
			mesh.getTexCoords().addAll(TEXCOORDS);
			mesh.getFaces().addAll(FACES);

			// マテリアルを生成
			material = new PhongMaterial();
			material.setDiffuseColor(Color.DARKGREEN);

			// メッシュを登録
			meshView.setMesh(mesh);
			meshView.setMaterial(material);

			// メッシュビューを追加
			this.getChildren().add(meshView);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteGround

	/**
	 * ステージ設定
	 * @param stage ステージ
	 */
	public void setStage(int stage){

		// ステージ１：ダーク・グリーン
		if(stage == 1){
			this.setVisible(true);
			material.setDiffuseColor(Color.DARKGREEN);

		// ステージ２：ダーク・オリーブ・グリーン
		}else if(stage == 2){
			material.setDiffuseColor(Color.DARKOLIVEGREEN);

		// ステージ３：ライト・ブルー
		}else if(stage == 3){
			material.setDiffuseColor(Color.LIGHTBLUE);

		// ステージ４：隠す
		}else if(stage == 4){
			this.setVisible(false);

		}

	} // end setStage

	/**
	 * 実行
	 */
	@Override
	public void run(){

	} // end run

}
