/**
 * スプライトグループ
 * <pre>
 * スプライトを複数管理するクラス。
 * </pre>
 */
abstract public class PRSpriteGroup {

	/** アプリケーション */
	protected PRApplication application = null;

	/** 時間 */
	public		int		time		= -1;

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 */
	public PRSpriteGroup(PRApplication application){
		this.application = application;
	}

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	abstract public void run();

	/**
	 * 時間を進める
	 */
	public void forward(){
		time++;
	}

	/**
	 * アプリケーション取得
	 */
	public PRApplication getPRApplication(){
		return application;
	}

}
