/**
 * ビル
 */
public class PRSpriteGroupBuilding extends PRSpriteGroup implements PRConstant {

	/** X補正位置 */
	private		double		xHosei		= 0.0;

	/** 配置パターン */
	private		String		strPattern	= null;

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param strParam 配置パターン
	 */
	public PRSpriteGroupBuilding(PRApplication application, String strParam){
		super(application);
		this.strPattern = strParam;
	}

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// X補正位置移動
		xHosei = xHosei - application.getPRSpritePrusher().mx;

		// 一定時間経過の場合、
		if((time % 15) == 0){

			// スプライトを生成
			PRSpriteBuilding spriteBuilding = new PRSpriteBuilding(super.getPRApplication(), strPattern, xHosei, time / 15);

			// スプライトを追加
			super.getPRApplication().addNode(spriteBuilding);

		} // end if 一定時間経過の場合

		// ２秒経ったら、
		if(time > 120){
			// スプライトグループを消す
			super.getPRApplication().removeSpriteGroup(this);
		}

	} // end run

}
