/**
 * キラー
 */
public class PRSpriteGroupKirar extends PRSpriteGroup implements PRConstant {

	/** 弾を発射するタイミング。出撃してからの時間を設定。-1は発射しない。 */
	private		int				timeTama		= -1;

	/** ポジション */
	private		int				pos				= -1;

	/** 効果音フラグ */
	private		boolean			flgSE			= false;

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param strParam 配置パターン
	 */
	public PRSpriteGroupKirar(PRApplication application, String strParam){

		super(application);
		this.timeTama = Integer.parseInt(strParam);

	} // end PRSpriteGroupKirar

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 10機出撃、
		if(time <= 135){

			// 一定時間経過の場合、
			if((time % 15) == 0){

				// ポジション＋１
				pos++;
				// ポジション補正
				pos = (pos >= 5)?0: pos;

				// スプライトを生成
				PRSpriteKirar spriteKirar = new PRSpriteKirar(super.getPRApplication(), this, pos, timeTama);

				// スプライトを追加
				super.getPRApplication().addNode(spriteKirar);

			} // end if 一定時間経過の場合

		} // end if 10機出撃

		// 10機出撃したら、
		if(time >= 135){
			// スプライトグループを消す
			super.getPRApplication().removeSpriteGroup(this);
		}

	} // end run

	/**
	 * 効果音スタート
	 */
	public void startWaveTurnKirar(){

		// 効果音が鳴っていない場合、
		if(!flgSE){

			// 効果音スタート
			application.startWaveTurnKirar();

			// 効果音はなった
			flgSE = true;

		}

	} // end startWaveTurnKirar

}
