import javafx.scene.Group;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Cylinder;
import javafx.scene.transform.Rotate;

/**
 * ゴルのレーザー（レーザー２）
 */
public class PRSpriteGroupLaserTeki2 extends PRSpriteGroup {

	/** 敵スプライト */
	private		Group				sprite			= null;

	/** 時間 */
	private		int					time			= 0;

	/** 速度 */
	public		double				mx				= 0;
	public		double				my				= 0;
	public		double				mz				= 0;

	/** 角度 */
	public		double				angleZ			= 0.0;
	public		double				angleX			= 0.0;

	/**
	 * 初期化
	 */
	public static void init() {

		try{
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param spritePrusher プレイヤー
	 */
	public PRSpriteGroupLaserTeki2(PRApplication application, Group sprite) {

		super(application);

		// 敵スプライトを保持
		this.sprite = sprite;

		// 座標
		double x = sprite.getTranslateX();
		double y = sprite.getTranslateY();
		double z = sprite.getTranslateZ();

		// 速度を設定
		this.mx = (application.getPRSpritePrusher().getTranslateX() - x) / 20;
		this.my = (application.getPRSpritePrusher().getTranslateY() - y) / 20;
		this.mz = (application.getPRSpritePrusher().getTranslateZ() - z) / 20;

		// 角度保持
		this.angleZ = 270 - sprite.getRotate();
		double radX = Math.atan2(my, mz);
		this.angleX = radX * 180 / Math.PI;

		// レーザーを生成
		PRSpriteLaserTeki2 spriteLaserTeki2 = new PRSpriteLaserTeki2(application, sprite, this, 60);

		// スプライトを追加
		application.addNode(spriteLaserTeki2);

		// 砲台チャージ音スタート
		application.startWaveChargeBattleShip();

	} // end PRSpriteGroupLaserTeki2

	/**
	 * 実行
	 */
	public void run(){

		// 時間設定
		time++;

		// １秒まで
		if(time < 60){

			// 何もしない

		// １秒
		}else if(time == 60){

			// 砲台発射音スタート
			application.startWaveFireBattleShip();

		// 1.5秒
		}else if(time < 90){

			// レーザーを生成
			PRSpriteLaserTeki2 spriteLaserTeki2 = new PRSpriteLaserTeki2(application, sprite, this, 0);

			// スプライトを追加
			application.addNode(spriteLaserTeki2);

		// 1.5秒
		}else if(time == 90){

			// スプライトグループを消す
			application.removeSpriteGroup(this);

		} // end if 時間

	} // end run

}
