/**
 * アステロイダー
 */
public class PRSpriteGroupShip extends PRSpriteGroup implements PRConstant {

	/** 攻撃パターン 右から */
	public static final int		POS_RIGHT		= 1;

	/** 攻撃パターン 左から */
	public static final int		POS_LEFT		= 2;

	/** 配置パターン */
	private		String			strPattern		= null;

	/** 攻撃位置 */
	private 	int				pos				= 0;

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param strParam 配置パターン
	 */
	public PRSpriteGroupShip(PRApplication application, String strParam){

		super(application);
		this.strPattern = strParam;

		// パターン別に設定
		if("後ろから攻撃".equals(strPattern) || "ゴル援護".equals(strPattern)){

			// プレイヤー取得
			PRSpritePrusher spritePrusher = application.getPRSpritePrusher();

			// X座標取得
			double xPrusher = spritePrusher.getTranslateX();

			// 左側にいる場合、
			if(xPrusher < 0.0){

				// 攻撃位置 右から
				pos = POS_RIGHT;

			// 右側にいる場合、
			}else{

				// 攻撃位置 左から
				pos = POS_LEFT;

			}

		} // end if パターン別に設定

	} // end PRSpriteGroupShip

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 後ろから攻撃／ゴル援護 以外の場合、
		if(!"後ろから攻撃".equals(strPattern) && !"ゴル援護".equals(strPattern)){

			// 一定時間経過の場合、
			if((time % 30) == 0){

				// スプライトを生成
				PRSpriteShip spriteShip = new PRSpriteShip(super.getPRApplication(), strPattern);

				// スプライトを追加
				super.getPRApplication().addNode(spriteShip);

			} // end if 一定時間経過の場合

			// ５秒経ったら、
			if(time > 300){
				// スプライトグループを消す
				super.getPRApplication().removeSpriteGroup(this);
			}

		// 上記以外の場合、
		}else{

			// 一定時間経過の場合、
			if((time % 10) == 0){

				// スプライトを生成
				PRSpriteShip spriteShip = new PRSpriteShip(super.getPRApplication(), strPattern, pos);

				// スプライトを追加
				super.getPRApplication().addNode(spriteShip);

			} // end if 一定時間経過の場合

			// １秒経ったら、
			if(time > 60){
				// スプライトグループを消す
				super.getPRApplication().removeSpriteGroup(this);
			}

		} // end if 後ろから攻撃の場合

	} // end run

}
