import java.io.File;

import javafx.scene.Group;;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.paint.Color;
import javafx.scene.image.Image;

import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;
import javafx.scene.shape.DrawMode;

import javafx.scene.transform.Rotate;
import javafx.geometry.Point3D;

import javafx.collections.ObservableList;
import javafx.geometry.Bounds;
import javafx.scene.Node;

/**
 * キラー
 * <pre>
 * OBjReaderを使わずに、一から作った3Dオブジェクト、キラーを登場させます。
 * 実は、シューティングゲーム編（Javaでゲームを作ろう１）からの登場です。
 * このオブジェクトは、わたし自身が勉強をするために、作った。という歴史というか、事情かな。
 * そんなのも、あったりします。
 * グラフ用紙に座標をとって、大変でした。
 * これはツール使わないと無理だな・・・と、悟った一場面となりました。
 * （Blenderを学ぶしかないか・・・って）
 * 今回は、このオブジェクトをせっかく作ったので、登場させます。
 * （ここだけの話です）
 * </pre>
 */
public class PRSpriteKirar extends PRSpriteT {

	/** イメージ */
	private static Image		image		= null;

	private final int			P_1_0_0		=  0;
	private final int			P_2_0_0		=  1;
	private final int			P_3_0_0		=  2;
	private final int			P_4_0_0		=  3;
	private final int			P_5_0_0		=  4;
	private final int			P_6_0_0		=  5;

	private final int			P_1_1_0		=  6;
	private final int			P_2_1_0		=  7;
	private final int			P_3_1_0		=  8;
	private final int			P_4_1_0		=  9;
	private final int			P_5_1_0		= 10;
	private final int			P_6_1_0		= 11;

	private final int			P_0_0_1		= 12;
	private final int			P_2_1_1		= 13;
	private final int			P_5_1_1		= 14;
	private final int			P_7_0_1		= 15;

	private final int			P_0_0_3		= 16;
	private final int			P_1_1_3		= 17;
	private final int			P_2_1_3		= 18;
	private final int			P_3_1_3		= 19;
	private final int			P_4_1_3		= 20;
	private final int			P_5_1_3		= 21;
	private final int			P_6_1_3		= 22;
	private final int			P_7_0_3		= 23;

	private final int			P_1_0_4		= 24;
	private final int			P_6_0_4		= 25;

	private final int			P_2_0_5		= 26;
	private final int			P_5_0_5		= 27;

	private final int			P_3_0_6		= 28;
	private final int			P_4_0_6		= 29;

	private final int			P_2_2_1		= 30;
	private final int			P_5_2_1		= 31;

	private final int			P_2_2_2		= 32;
	private final int			P_5_2_2		= 33;
	private final int			P_2_1_2		= 34;
	private final int			P_5_1_2		= 35;

	private			float[]		points = {
		-1.5f,  0.5f,  2.0f,
		-1.0f,  0.5f,  2.0f,
		-0.5f,  0.5f,  2.0f,
		 0.5f,  0.5f,  2.0f,
		 1.0f,  0.5f,  2.0f,
		 1.5f,  0.5f,  2.0f,

		-1.5f,  0.0f,  2.0f,
		-1.0f,  0.0f,  2.0f,
		-0.5f,  0.0f,  2.0f,
		 0.5f,  0.0f,  2.0f,
		 1.0f,  0.0f,  2.0f,
		 1.5f,  0.0f,  2.0f,

		-2.0f,  0.5f,  1.0f,
		-1.0f,  0.0f,  1.0f,
		 1.0f,  0.0f,  1.0f,
		 2.0f,  0.5f,  1.0f,

		-2.0f,  0.5f, -1.0f,
		-1.5f,  0.0f, -1.0f,
		-1.0f,  0.0f, -1.0f,
		-0.5f,  0.0f, -1.0f,
		 0.5f,  0.0f, -1.0f,
		 1.0f,  0.0f, -1.0f,
		 1.5f,  0.0f, -1.0f,
		 2.0f,  0.5f, -1.0f,

		-1.5f,  0.5f, -1.5f,
		 1.5f,  0.5f, -1.5f,

		-1.0f,  0.5f, -2.0f,
		 1.0f,  0.5f, -2.0f,

		-0.5f,  0.5f, -2.5f,
		 0.5f,  0.5f, -2.5f,

		-1.0f, -0.5f,  1.0f,
		 1.0f, -0.5f,  1.0f,

		-1.0f, -0.5f,  0.0f,
		 1.0f, -0.5f,  0.0f,
		-1.0f,  0.0f,  0.0f,
		 1.0f,  0.0f,  0.0f,

	};

	/** グレー部分 */
	private final int[]			faces_0 = {
		P_1_1_0, 0, P_0_0_1, 0, P_1_1_3, 0,
		P_0_0_1, 0, P_0_0_3, 0, P_1_1_3, 0,
		P_6_1_0, 0, P_6_1_3, 0, P_7_0_3, 0,
		P_6_1_0, 0, P_7_0_3, 0, P_7_0_1, 0,
		P_2_1_1, 0, P_2_1_3, 0, P_5_1_3, 0,
		P_2_1_1, 0, P_5_1_3, 0, P_5_1_1, 0,
		P_0_0_3, 0, P_1_0_4, 0, P_1_1_3, 0,
		P_6_1_3, 0, P_6_0_4, 0, P_7_0_3, 0,
		P_2_1_3, 0, P_2_0_5, 0, P_3_0_6, 0,
		P_2_1_3, 0, P_3_0_6, 0, P_3_1_3, 0,
		P_4_1_3, 0, P_4_0_6, 0, P_5_0_5, 0,
		P_4_1_3, 0, P_5_0_5, 0, P_5_1_3, 0,
		P_3_1_3, 0, P_3_0_6, 0, P_4_0_6, 0,
		P_3_1_3, 0, P_4_0_6, 0, P_4_1_3, 0,

		// 上部
		P_2_2_1, 0, P_2_2_2, 0, P_5_2_2, 0,
		P_2_2_1, 0, P_5_2_2, 0, P_5_2_1, 0,
		P_5_2_1, 0, P_5_1_1, 0, P_2_1_1, 0,
		P_5_2_1, 0, P_2_1_1, 0, P_2_2_1, 0,

		// 横面
		P_2_2_1, 0, P_2_1_1, 0, P_2_1_2, 0,
		P_2_2_1, 0, P_2_1_2, 0, P_2_2_2, 0,
		P_5_2_2, 0, P_5_1_2, 0, P_5_1_1, 0,
		P_5_2_2, 0, P_5_1_1, 0, P_5_2_1, 0,

		// 背面
		P_4_1_0, 0, P_4_0_0, 0, P_3_0_0, 0,
		P_4_1_0, 0, P_3_0_0, 0, P_3_1_0, 0,
		P_6_1_0, 0, P_7_0_1, 0, P_6_0_0, 0,
		P_1_1_0, 0, P_1_0_0, 0, P_0_0_1, 0,

		// 下面
		P_5_0_0, 0, P_5_0_5, 0, P_2_0_5, 0,
		P_5_0_0, 0, P_2_0_5, 0, P_2_0_0, 0,
		P_5_0_5, 0, P_4_0_6, 0, P_3_0_6, 0,
		P_5_0_5, 0, P_3_0_6, 0, P_2_0_5, 0,

		P_1_0_0, 0, P_1_0_4, 0, P_0_0_3, 0,
		P_1_0_0, 0, P_0_0_3, 0, P_0_0_1, 0,
		P_6_0_0, 0, P_7_0_1, 0, P_7_0_3, 0,
		P_6_0_0, 0, P_7_0_3, 0, P_6_0_4, 0,

	};

	/** 青部分 */
	private final int[]			faces_1 = {
		P_2_2_2, 0, P_3_1_3, 0, P_4_1_3, 0,
		P_2_2_2, 0, P_4_1_3, 0, P_5_2_2, 0,
		P_2_2_2, 0, P_2_1_2, 0, P_3_1_3, 0,
		P_5_2_2, 0, P_4_1_3, 0, P_5_1_2, 0,
		P_1_1_0, 0, P_1_1_3, 0, P_2_1_3, 0,
		P_1_1_0, 0, P_2_1_3, 0, P_2_1_0, 0,
		P_5_1_0, 0, P_5_1_3, 0, P_6_1_3, 0,
		P_5_1_0, 0, P_6_1_3, 0, P_6_1_0, 0,
		P_1_1_3, 0, P_1_0_4, 0, P_2_0_5, 0,
		P_1_1_3, 0, P_2_0_5, 0, P_2_1_3, 0,
		P_5_1_3, 0, P_5_0_5, 0, P_6_0_4, 0,
		P_5_1_3, 0, P_6_0_4, 0, P_6_1_3, 0,
		P_6_1_0, 0, P_6_0_0, 0, P_5_0_0, 0,
		P_6_1_0, 0, P_5_0_0, 0, P_5_1_0, 0,
		P_2_1_0, 0, P_2_0_0, 0, P_1_0_0, 0,
		P_2_1_0, 0, P_1_0_0, 0, P_1_1_0, 0,
		P_2_0_0, 0, P_2_0_5, 0, P_1_0_4, 0,
		P_2_0_0, 0, P_1_0_4, 0, P_1_0_0, 0,
		P_6_0_0, 0, P_6_0_4, 0, P_5_0_5, 0,
		P_6_0_0, 0, P_5_0_5, 0, P_5_0_0, 0,

	};

	/** 赤部分 */
	private final int[]			faces_2 = {
		P_5_1_0, 0, P_5_0_0, 0, P_4_0_0, 0,
		P_5_1_0, 0, P_4_0_0, 0, P_4_1_0, 0,
		P_3_1_0, 0, P_3_0_0, 0, P_2_0_0, 0,
		P_3_1_0, 0, P_2_0_0, 0, P_2_1_0, 0,
	};

	/** テクスチャ部分 */
	private final int[]			faces_3 = {
		P_2_1_0, 0, P_2_1_1, 1, P_5_1_1, 2,
		P_2_1_0, 0, P_5_1_1, 2, P_5_1_0, 3
	};

	/** ダミーテクスチャ部分 */
	private final float[]		texCoords = {
		0, 0
	};

	/** テクスチャ */
	private final float[]		texCoords_3 = {
		0, 0,
		0, 1,
		1, 1,
		1, 0
	};

	/** 排気口 */
	private final Color[]		COLORS = {
		Color.color(0.4, 0.0, 0.0),
		Color.color(0.5, 0.0, 0.0),
		Color.color(0.6, 0.0, 0.0),
		Color.color(0.7, 0.0, 0.0),
		Color.color(0.8, 0.0, 0.0),
		Color.color(0.9, 0.0, 0.0),
		Color.color(1.0, 0.0, 0.0)
	};

	/** メッシュビュー */
	private		MeshView			meshView0		= null;
	private		MeshView			meshView1		= null;
	private		MeshView			meshView2		= null;
	private		MeshView			meshView3		= null;

	/** マテリアル */
	private		PhongMaterial		material0		= null;
	private		PhongMaterial		material1		= null;
	private		PhongMaterial		material2		= null;
	private		PhongMaterial		material3		= null;

	/** スプライトグループ */
	private		PRSpriteGroupKirar	spriteGroup		= null;

	/** 時間 */
	private		int					time			= 0;

	/** 弾を発射するタイミング。出撃してからの時間を設定。-1は発射しない。 */
	private		int					timeTama		= -1;

	/**
	 * 初期化
	 */
	public static void init() {

		// テクスチャ画像を作成
		String filePath = new File("imagePRSpriteKirar.jpg").toURI().toString();
		PRSpriteKirar.image = new Image(filePath);

	} // end init

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param spriteGroup グループ
	 * @param pos ポジション
	 * @param timeTama 弾を発射するタイミング。出撃してからの時間を設定。-1は発射しない。
	 */
	public PRSpriteKirar(PRApplication application, PRSpriteGroupKirar spriteGroup, int pos, int timeTama){

		// スーパークラスを呼び出す
		super(application);

		// スプライトグループを保持
		this.spriteGroup = spriteGroup;

		// 弾を発射するタイミングを保持
		this.timeTama = timeTama;

		//
		// グレー部分
		//

		// メッシュビューを作成
		meshView0 = new MeshView();

		// メッシュを作成
		TriangleMesh mesh0 = new TriangleMesh();

		mesh0.getPoints().addAll(points);
		mesh0.getTexCoords().addAll(texCoords);
		mesh0.getFaces().addAll(faces_0);

		// マテリアルを作成
		material0 = new PhongMaterial();
		material0.setDiffuseColor(Color.web("808080"));

		// メッシュを登録
		meshView0.setMesh(mesh0);
		meshView0.setMaterial(material0);

		// メッシュビューを追加
		this.getChildren().add(meshView0);

		//
		// 青部分
		//

		// メッシュビューを作成
		meshView1 = new MeshView();

		// メッシュを作成
		TriangleMesh mesh1 = new TriangleMesh();

		mesh1.getPoints().addAll(points);
		mesh1.getTexCoords().addAll(texCoords);
		mesh1.getFaces().addAll(faces_1);

		// マテリアルを作成
		material1 = new PhongMaterial();
		material1.setDiffuseColor(Color.web("000060"));

		// メッシュを登録
		meshView1.setMesh(mesh1);
		meshView1.setMaterial(material1);

		// メッシュビューを追加
		this.getChildren().add(meshView1);

		//
		// 赤部分
		//

		// メッシュビューを作成
		meshView2 = new MeshView();

		// メッシュを作成
		TriangleMesh mesh2 = new TriangleMesh();

		mesh2.getPoints().addAll(points);
		mesh2.getTexCoords().addAll(texCoords);
		mesh2.getFaces().addAll(faces_2);

		// マテリアルを作成
		material2 = new PhongMaterial();
		material2.setDiffuseColor(Color.web("800000"));

		// メッシュを登録
		meshView2.setMesh(mesh2);
		meshView2.setMaterial(material2);

		// メッシュビューを追加
		this.getChildren().add(meshView2);

		//
		// テクスチャ部分
		//

		// メッシュビューを作成
		meshView3 = new MeshView();

		// メッシュを作成
		TriangleMesh mesh3 = new TriangleMesh();

		mesh3.getPoints().addAll(points);
		mesh3.getTexCoords().addAll(texCoords_3);
		mesh3.getFaces().addAll(faces_3);

		// マテリアルを作成
		PhongMaterial material3 = new PhongMaterial();
		material3.setDiffuseMap(PRSpriteKirar.image);

		// メッシュを登録
		meshView3.setMesh(mesh3);
		meshView3.setMaterial(material3);

		// メッシュビューを追加
		this.getChildren().add(meshView3);

		// 回転軸を設定
		super.setRotationAxis(Rotate.X_AXIS);

		// 拡大／縮小する
		super.setScaleX(0.25);
		super.setScaleY(0.25);
		super.setScaleZ(0.25);

		// 座標設定
		super.setTranslateX((pos - 2) * 1.2);
		super.setTranslateY(-1.5);
		super.setTranslateZ(300);

	} // end PRSpriteKirar

	/**
	 * 実行
	 */
	public void run(){

		// 時間＋１
		time++;

		// 座標取得
		double x = super.getTranslateX();
		double y = super.getTranslateY();
		double z = super.getTranslateZ();

		//
		// 移動
		//

		// 2.41666…秒（Z位置が10のところまで）
		if(time < 145){

			// 移動
			z = z - 2;

		// 2.91666…秒（0.5秒間）
		}else if(time < 175){

			// 移動
			y = y - 0.06;

			// 2.41666…秒（Z位置が10のところ）
			if(time == 145){

				// 効果音スタート
				spriteGroup.startWaveTurnKirar();

			}

		// 上記以外、
		}else{

			// 移動
			z = z + 2;

			// 画面の外にでた場合、
			if(z > 300){
				// 削除する
				super.remove();
			}

		} // end if 時間

		// 移動
		super.setTranslateY(y);
		super.setTranslateZ(z);

		//
		// 回転
		//

		// 2.41666…秒（Z位置が10のところまで）
		if(time < 145){

			// 何もしない

		// 2.91666…秒
		}else if(time < 175){

			// 回転
			super.setRotate(super.getRotate() - 6);

		} // end if 時間

		//
		// 飛んでる雰囲気
		//

		// 時間がきたら、
		if(time % 8 == 0){

			// 飛んでる雰囲気を出す
			material2.setDiffuseColor(COLORS[((int)(Math.random() * 7))]);

		}

		//
		// 敵の弾
		//

		// 敵の弾を発射する場合、
		if(timeTama != -1){

			// 時間−１
			timeTama--;

			// 時間が来たら、
			if(timeTama == 0){

				// 敵の弾を生成
				PRSpriteTamaTeki1 spriteTamaTeki = new PRSpriteTamaTeki1(application, this, 1.0);
				// 敵の弾を追加
				application.addNode(spriteTamaTeki);

				// 敵の弾音スタート
				application.startWaveTamaTeki();

			}

		} // end if 敵の弾を発射していない場合

		//
		// 当たり判定
		//

		// 爆発していない場合、
		if(!flgBomb){

			// 境界を取得
			Bounds boundsThis = this.getBoundsInParent();

			// スプライト一覧を取得
			ObservableList<Node> nodeLst = application.getNodeLst();

			// スプライト一覧の件数を取得
			int countNodeLst = nodeLst.size();

			// スプライト一覧の件数分、ループ
			for(int i = 0; i < countNodeLst; i++){

				// スプライトを取得
				Node node = nodeLst.get(i);

				// 弾の場合、
				if(node instanceof PRSpriteTama){

					// 当たっている場合、
					if(boundsThis.intersects(node.getBoundsInParent())){

						// 爆発
						flgBomb = true;

						// 弾を削除
						application.removeNode(node);

						// 爆発を生成
						PRSpriteBomb spriteBomb = new PRSpriteBomb(application, this, 0.05);

						// アプリケーションに爆発を追加
						application.addNode(spriteBomb);

						// 点数追加
						application.addScore(300);

						// 爆発音スタート
						application.startWaveBomb();

						// ループを抜ける
						break;

					} // end if 当たっている場合

				} // end if 弾の場合

			} // end for スプライト一覧の件数分、ループ

		} // end if 爆発していない場合

	} // end run

}
