/**
 * 敵スプライト
 */
public abstract class PRSpriteT extends PRSprite {

	/** アプリケーション */
	public		PRApplication		application			= null;

	/** 爆発状態 */
	protected	boolean				flgBomb				= false;

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 */
	public PRSpriteT(PRApplication application) {

		super(application);

		// アプリケーションを保持
		this.application = application;

	}

	/**
	 * 実行
	 */
	abstract public void run();

	/**
	 * 爆発状態取得
	 * @return true−爆発／false−爆発していない
	 */
	public boolean isBomb() {
		return flgBomb;
	}

	/**
	 * 当たり判定範囲X
	 */
	public double getHaniX() {
		return 0.6;
	}

	/**
	 * 当たり判定範囲Y
	 */
	public double getHaniY() {
		return 0.6;
	}

	/**
	 * 当たり判定範囲Z
	 */
	public double getHaniZ() {
		return 0.6;
	}

}
