import javafx.geometry.Point3D;
import javafx.collections.ObservableList;
import javafx.scene.Node;
import javafx.geometry.Bounds;

/**
 * ズババビーン
 */
public class PRSpriteZBB extends PRSpriteT {

	/** 回転速度 */
	private		double			s			= Math.random() * 4 + 2;

	/**
	 * 初期化
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteZBB.class, "3d/Zbb.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param stage ステージ
	 */
	public PRSpriteZBB(PRApplication application){

		// スーパークラスを呼び出す
		super(application);

		try{

			// X設定
			double x = Math.random() * 20.0 - 10.0;

			// X設定
			super.setTranslateX(x);

			// Z設定
			super.setTranslateZ(150);

			// オブジェクト
			ObjReader.create(this);

			// 回転軸
			Point3D p = new Point3D(Math.random() - 0.5, Math.random() - 0.5, Math.random() - 0.5);

			// 回転軸を設定
			super.setRotationAxis(p);

			// 拡大／縮小する
			super.setScaleX(0.8);
			super.setScaleY(0.8);
			super.setScaleZ(0.8);

			// 速度設定
			mz = -1.8;

			// 影を設定
			application.addShadow(this, 0.6);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteZBB

	/**
	 * 実行
	 */
	@Override
	public void run(){

		//
		// X方向
		//

		// 移動量取得
		double mx = -application.getPRSpritePrusher().mx;

		// 座標計算
		double x = super.getTranslateX();
		x = x + mx;

		// 移動
		super.setTranslateX(x);

		//
		// Z方向
		//

		// 座標取得
		double z = super.getTranslateZ();

		// 座標加算
		z = z + mz;

		// 画面の外にでた場合、
		if(z < 0){
			// 削除する
			super.remove();
		}

		// 移動
		super.setTranslateZ(z);

		// 回転
		super.setRotate(getRotate() + this.s);

	} // end run

	/**
	 * 当たり判定範囲X
	 */
	@Override
	public double getHaniX() {
		return 0.2;
	}

	/**
	 * 当たり判定範囲Y
	 */
	@Override
	public double getHaniY() {
		return 0.2;
	}

	/**
	 * 当たり判定範囲Z
	 */
	@Override
	public double getHaniZ() {
		return 0.4;
	}

}
